﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Diagnostics;
using System.Data.OleDb;
using System.Text;

namespace aspnetforumsistemi
{
    public partial class sorugoster : System.Web.UI.Page
    {
        protected OleDbConnection baglanti;
        protected string sorgusoruid = HttpContext.Current.Request.QueryString["soruid"];
        protected int cevapno = 1;
        protected void Page_Load(object sender, EventArgs e)
        {
            string veritabani = null;
            veritabani = "Provider=Microsoft.ACE.OLEDB.12.0; DATA Source=" + Server.MapPath("App_Data/forum.accdb");
            baglanti = new OleDbConnection(veritabani);
            baglanti.Open();

            sorularigoster();
            cevaplarigoster();
        }
        protected void sorularigoster()
        {
            OleDbDataAdapter dtAdapter = null;
            OleDbCommand komut = null;
            DataTable dt = new DataTable();
            StringBuilder sorgu = new StringBuilder();
            sorgu.Append("SELECT * FROM sorular ");
            sorgu.Append(" WHERE soruid=" + sorgusoruid + " ");
            dtAdapter = new OleDbDataAdapter(sorgu.ToString(), baglanti);
            dtAdapter.Fill(dt);

            if (dt.Rows.Count > 0)
            {
                this.lblsoru.Text = dt.Rows[0]["soru"].ToString();
                this.lblaciklama.Text = dt.Rows[0]["detay"].ToString();
                this.lblisim.Text = "<b>İsim : </b>" + dt.Rows[0]["isim"].ToString();
                this.lbltarih.Text = "<b>Soru Tarihi : </b>" + Convert.ToDateTime(dt.Rows[0]["sorutarih"]).ToString("dd/MM/yyyy HH:mm").ToString();
                this.lblcevap.Text = "<b>Cevap Sayısı : </b>" + dt.Rows[0]["cevap"].ToString();
                this.lblgoruntulenme.Text = "<b>Görüntülenme Sayısı : </b>" + dt.Rows[0]["goruntulenme"].ToString();
            }

            //*** Görüntülenme sayısını güncelliyoruz....  ***'
            sorgu.Remove(0, sorgu.Length);
            sorgu.Append(" UPDATE sorular SET [goruntulenme] = [goruntulenme] + 1 ");
            sorgu.Append(" WHERE soruid = @soruid ");
            komut = new OleDbCommand(sorgu.ToString(), baglanti);
            komut.Parameters.Add("@soruid", OleDbType.VarChar).Value =sorgusoruid.ToString();
            komut.ExecuteNonQuery();

        }


        protected void cevaplarigoster()
        {
            StringBuilder sorgu = new StringBuilder();
            OleDbCommand komut = null;

            sorgu.Append(" SELECT * FROM cevaplar ");
            sorgu.Append(" WHERE soruid = " + sorgusoruid + " ");

            OleDbDataReader dtReader = null;
            komut = new OleDbCommand(sorgu.ToString(), baglanti);
            dtReader = komut.ExecuteReader();

            //*** cevapgoruntuleyici isimli repetarımıza ceveplar geliyor.... ***'
            cevapgoruntuleyici.DataSource = dtReader;
            cevapgoruntuleyici.DataBind();

            dtReader.Close();
            dtReader = null;

        }

        protected void Page_UnLoad(object sender, EventArgs e)
        {
            baglanti.Close();
            baglanti = null;
        }

        protected void btnkaydet_Click(object sender, EventArgs e)
        {
            StringBuilder sorgu = new StringBuilder();
            OleDbCommand komut = null;

            //*** Cevap Ekleme***'
            sorgu.Append(" INSERT INTO cevaplar (soruid,tarih,detay,isim) ");
            sorgu.Append(" VALUES ");
            sorgu.Append(" (@soruid,@tarih,@detay,@isim) ");
            komut = new OleDbCommand(sorgu.ToString(), baglanti);
            komut.Parameters.Add("@sQuestionID", OleDbType.VarChar).Value = sorgusoruid.ToString();
            komut.Parameters.Add("@sCreateDate", OleDbType.Date).Value = DateTime.Now.ToString();
            komut.Parameters.Add("@sDetails", OleDbType.VarChar).Value = this.txtdetay.Text;
            komut.Parameters.Add("@sName", OleDbType.VarChar).Value = this.txtisim.Text;
            komut.ExecuteNonQuery();

            //*** Cevap Sayısını Bir Artttır ***'
            sorgu.Remove(0, sorgu.Length);
            sorgu.Append(" UPDATE sorular SET cevap = cevap + 1 ");
            sorgu.Append(" WHERE soruid = @soruid ");
            komut = new OleDbCommand(sorgu.ToString(), baglanti);
            komut.Parameters.Add("@soruid", OleDbType.VarChar).Value = sorgusoruid.ToString();
            komut.ExecuteNonQuery();

            Response.Redirect("sorugoster.aspx?soruid=" + sorgusoruid);
        }
        protected void cevapgoruntuleyici_ItemDataBound(object sender, RepeaterItemEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.Item | e.Item.ItemType == ListItemType.AlternatingItem)
            {
                //*** Numara ***'
                Label lblcevapno = (Label)e.Item.FindControl("lblcevapno");
                if ((lblcevapno != null))
                {
                    lblcevapno.Text = "Cevap Numarası : " + cevapno;
                    cevapno = cevapno + 1;
                }

                //*** Cevapın Detayı www.aspnetornekleri.com ***'
                Label lblcevapdetay = (Label)e.Item.FindControl("lblcevapdetay");
                if ((lblcevapdetay != null))
                {
                    lblcevapdetay.Text = (string)DataBinder.Eval(e.Item.DataItem, "detay");
                }

                //*** Cevaplayan  www.aspnetornekleri.com***'
                Label lblcevaplayan = (Label)e.Item.FindControl("lblcevaplayan");
                if ((lblcevaplayan != null))
                {
                    lblcevaplayan.Text = (string)DataBinder.Eval(e.Item.DataItem, "isim");
                }

                //*** Cevap Tarihi www.aspnetornekleri.com ***'
                Label lblcevaptarih = (Label)e.Item.FindControl("lblcevaptarih");
                if ((lblcevaptarih != null))
                {
                    lblcevaptarih.Text = Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "tarih")).ToString("dd/MM/yyyy HH:mm");
                }

            }

        }

    
    }

}